import 'dart:async';

import 'resourcestate.dart';

//Responds when a range of bytes are request and loaded
class FileStateProvider {
  static const WAITING = 1;
  static const CALLED = 2;
  static const COMPLETED = 3;
  StreamController<Null> _done = new StreamController<Null>.broadcast();
  StreamController<ResourceState> _next =
      new StreamController<ResourceState>.broadcast();
  //length:state
  Map<int, List<int>> calls = new Map<int, List<int>>();
  close() {
    _next.close();
    _done.add(null);
    _done.close();
  }

  //Describe current state of file read
  pushState(int length, int state) {
    if (state == CALLED) {
      if (calls[length] == null) {
        calls[length] = new List<int>();
        calls[length].add(state);
      } else {
        calls[length].add(state);
      }
    }
    List<int> deletes = [];
    List<ResourceState> execute = new List<ResourceState>();
    calls.forEach((int length1, List<int> states) {
      if (state == WAITING) {
        if (length >= length1) {
          deletes.add(length1);
          if (!execute.contains(length)) {
            execute.add(new ResourceState(length));
          }
          return;
        }
      } else if (state == COMPLETED) {
        deletes.add(length1);
        if (!execute.contains(length)) {
          execute.add(new ResourceState(length));
        }
        return;
      }
    });
    deletes.forEach((int del) {
      calls.remove(del);
    });
    if (execute.length > 0) {
      execute.forEach((ex) {
        _next.add(ex);
      });
    }
  }

  //Identifes when requested byte range is available
  Stream<ResourceState> ready() {
    return _next.stream;
  }

  //Identifes when all the entire file is downloaded
  Stream<Null> get done {
    return _done.stream;
  }
}
