import 'dart:async';

//Used to Identify when a File or RemoteSource is no longer in use
class FileState {
  static StreamController<dynamic> _free = new StreamController<dynamic>();
  static Map<dynamic, List<int>> _states = new Map<dynamic, List<int>>();
  static void addState(dynamic file) {
    String runtime = file.runtimeType.toString();
    if (runtime != '_File' && runtime != 'RemoteSource') {
      throw "Streamer accepts only File or RemoteSource";
    }
    if (FileState._states[file] == null) {
      FileState._states[file] = new List<int>();
    }
    FileState._states[file].add(0);
  }

  static void removeState(dynamic file) {
    FileState._states[file].removeLast();
    if (FileState._states[file].length == 0) {
      _free.add(file);
    }
  }

//Stream<File> or Stream<RemoteSource>
  static Stream<dynamic> get notinuse {
    return FileState._free.stream;
  }
}
